//*****************************************************************************************************
//  1. t@C
//		WorkScheduler.cpp
//----------------------------------------------------------------------------------------------------
//  2. @\
//		AvP[VpNX̒`s܂B
//----------------------------------------------------------------------------------------------------
//  3. l
//----------------------------------------------------------------------------------------------------
//  4. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************

#include "stdafx.h"
#include "WorkScheduler.h"
#include "WorkSchedulerDlg.h"
#include "ManualEditDocument.h"
#include "ManualEditChildWnd.h"
#include "ManualEditChildWnd1.h"
#include "ManualEditView1.h"
#include "ManualEditView2.h"
#include "ManualEditView3.h"
#include "System.h"
#include "DataManager.h"
#include "Const.h"
#include "LoginDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

BEGIN_MESSAGE_MAP(CWorkSchedulerApp, CWinApp)
	//{{AFX_MSG_MAP(CWorkSchedulerApp)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
		//        ̈ʒuɐR[hҏWȂłB
	//}}AFX_MSG
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

// B CWorkSchedulerApp IuWFNg
CWorkSchedulerApp theApp;

CConst *g_pConst;
CSystem *g_pSystem;
CDataManager *g_pDataManager;

//*****************************************************************************************************
//  1. ֐
//		CWorkSchedulerApp::InitInstance
//----------------------------------------------------------------------------------------------------
//  2. @\
//		CX^X
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		BOOL		FALSE
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		ƕҐ_CAO\B
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
BOOL CWorkSchedulerApp::InitInstance()
{
	AfxEnableControlContainer();

	// WIȏ
	// ̋@\gpAst@C̃TCY
	//  Έȉ̓̏[`̒sKvȂ̂폜
	//  B

#ifdef _AFXDLL
	Enable3dControls();			// L DLL  MFC gꍇ͂R[ĂB
#else
	Enable3dControlsStatic();	// MFC ƐÓIɃNꍇ͂R[ĂB
#endif

	::CoInitialize(NULL);

	// VXeǗNX
	g_pSystem = new CSystem;
	if (!g_pSystem->Initialize())
		return FALSE;

	// 萔NX
	g_pConst = new CConst;

	// f[^ǗNX
	g_pDataManager = new CDataManager;

	// OC
	{
		CLoginDlg cLoginDlg;
		if (cLoginDlg.DoModal() == IDCANCEL)
			return FALSE;
	}

	// 蓮ҐEBhEphLgev[g쐬
	m_pManualDocTemplate1 = new CMultiDocTemplate(
		IDR_MANUAL_FRAME,
		RUNTIME_CLASS(CManualEditDocument),
		RUNTIME_CLASS(CManualEditChildWnd1),
		RUNTIME_CLASS(CManualEditView1));
	AddDocTemplate(m_pManualDocTemplate1);
	DestroyMenu(m_pManualDocTemplate1->m_hMenuShared);
	m_pManualDocTemplate1->m_hMenuShared = NULL;

	m_pManualDocTemplate2 = new CMultiDocTemplate(
		IDR_MANUAL_FRAME,
		RUNTIME_CLASS(CManualEditDocument),
		RUNTIME_CLASS(CManualEditChildWnd),
		RUNTIME_CLASS(CManualEditView2));
	AddDocTemplate(m_pManualDocTemplate2);
	DestroyMenu(m_pManualDocTemplate2->m_hMenuShared);
	m_pManualDocTemplate2->m_hMenuShared = NULL;

	m_pManualDocTemplate3 = new CMultiDocTemplate(
		IDR_MANUAL_FRAME,
		RUNTIME_CLASS(CManualEditDocument),
		RUNTIME_CLASS(CManualEditChildWnd),
		RUNTIME_CLASS(CManualEditView3));
	AddDocTemplate(m_pManualDocTemplate3);
	DestroyMenu(m_pManualDocTemplate3->m_hMenuShared);
	m_pManualDocTemplate3->m_hMenuShared = NULL;

	CWorkSchedulerDlg dlg;
	m_pMainWnd = g_pSystem->m_pMainDlg = new CWorkSchedulerDlg;
	((CDialog *)m_pMainWnd)->Create(IDD_WORKSCHEDULER_DIALOG);

	// _CAOĂAvP[ṼbZ[W |vJńA
	// AvP[VI邽߂ FALSE ԂĂB
	return TRUE;
}

//*****************************************************************************************************
//  1. ֐
//		CWorkSchedulerApp::ExitInstance
//----------------------------------------------------------------------------------------------------
//  2. @\
//		CX^XI
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		BOOL		FALSE
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		f[^ǗNXB
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
int CWorkSchedulerApp::ExitInstance()
{
	if (g_pConst != NULL) {
		delete g_pConst;
		g_pConst = NULL;
	}

	if (g_pSystem != NULL) {
		delete g_pSystem;
		g_pSystem = NULL;
	}

	if (g_pDataManager != NULL) {
		delete g_pDataManager;
		g_pDataManager = NULL;
	}

	::CoUninitialize();

	return CWinApp::ExitInstance();
}
